﻿/**
ホットキー

History:
	$(HIST_VER 1.00β13,
		$(HIST_MSG HOTKEYVALUEをpackage移動 etc.negui.control.hotkey.hotkey -> etc.negui.input.keyboard.keyboard。)
	)
*/
module etc.negui.control.hotkey.hotkey;

debug import std.stdio: wl = writefln;
debug(hotkey) void main() {}

import win32.windows;
import win32.commctrl;

import etc.negui.system.base;
public import etc.negui.negui;
public import etc.negui.control.control;
public import etc.negui.input.keyboard.keyboard;


/***/
class HotKey: Control, ICommonControl {
	mixin MixInCommonControl;
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_P 処理内容変更。)
		)
	*/
	this(NeGui Owner, ITEM_ID Id) {
		NEGUIINFO NeGuiInfo;
		
		NeGuiInfo.owner     = Owner;
		NeGuiInfo.id        = Id;
		
		this(NeGuiInfo);
	}
	override this(ref NEGUIINFO NeGuiInfo) {
		NeGuiInfo.className = Text(HOTKEY_CLASS);
		NeGuiInfo.style |= ES_CENTER;
		
		super(NeGuiInfo);
	}

	/**
	History:
		$(HIST_VER 1.00β17,
			$(HIST_B コントロールから取得するキー情報が壊れていた。)
		)
	*/
	HOTKEYVALUE value() {
		auto Value=LOWORD(send(HKM_GETHOTKEY, NONE, NONE));
		
		HOTKEYVALUE Hotkey;
		Hotkey.Mod = cast(HOTKEY)HIBYTE(Value);
		Hotkey.Key = cast(KEY)LOBYTE(Value);
		
		return Hotkey;
	}

	/**
	*/
	void value(HOTKEYVALUE Value) {
		send(HKM_SETHOTKEY, MAKEWORD(Value.Key, Value.Mod), NONE);
	}

	/**
	History:
		$(HIST_VER 1.101,
			$(HIST_S NONEのドキュメントが文字化け。)
		)
	*/
	enum RULE {
		ALT = HKCOMB_A, /// ALTキー
		CONTROL=HKCOMB_C, /// Ctrlキー
		SHIT=HKCOMB_S, /// Shiftキー
		CTRL_ALT=HKCOMB_CA, /// Ctrl + ALTキー
		SHIT_ALT=HKCOMB_SA, /// Shift + ALTキー
		SHIFT_CTRL=HKCOMB_SC, /// Shift + Ctrlキー
		SCA=HKCOMB_SCA, /// Shift + Ctrl + ALTキー
		NONE = HKCOMB_NONE, /// 修飾されていない。
	}
	/**
	*/
	void rule(RULE Rule, HOTKEY Mod) {
		send(HKM_SETRULES, Rule, MAKELPARAM(Mod, 0));
	}
}



