﻿/**

Bugs:
	あまりにも作りがひどい。

Note:
	NeGuiへ移動すべき。
	移動したけど要調整。

History:
	$(HIST_VER 1.00β19,
		$(HIST_NEW)
	)
*/
module etc.negui.mutex;

debug import std.stdio: wl = writefln;
debug(mutex) void main() {}

import std.contracts;

import win32.windows;

import etc.negui.system.base;
import etc.negui.environ.security;

//import nemuxi.system.exception;

///
class MutexException: NeGuiException {
	mixin MixInNeGuiException;
}

/**
History:
	$(HIST_VER 1.100,
		$(HIST_P hMutexをHandleRaiiに合わせる。)
	)
*/
class Mutex: HandleRaii {
	//protected HANDLE hMutex;
	protected alias Handle hMutex;
	mixin KillResource!("ミューテックス", hMutex, CloseHandle, 0);

	/**
	*/
	enum ACCESSFLAG {
		NONE        = 0,                /// 
		ALL         = MUTEX_ALL_ACCESS, /// ミューテックスオブジェクトで設定できるすべてのアクセスフラグを指定します。
		SYNCHRONIZE = SYNCHRONIZE,      /// Windows NT/2000：すべての「」（待機関数）がミューテックスの所有権を要求するために、また 関数が所有権を解放するために、ミューテックスハンドルを使うことを認めます。
	}
	const protected HandleRaii Duplicate(HANDLE SourceProcessHandle, HANDLE TargetProcessHandle, ACCESSFLAG AccessFlags, bool Inheritance, DUPOPTION DupOption) {
		return Duplicate(SourceProcessHandle, TargetProcessHandle, AccessFlags, Inheritance, DupOption);
	}
	override const protected HandleRaii Duplicate(HANDLE SourceProcessHandle, HANDLE TargetProcessHandle, DWORD AccessFlags, bool Inheritance, DUPOPTION DupOption) {
		return super.Duplicate(SourceProcessHandle, TargetProcessHandle, AccessFlags, Inheritance, DupOption);
	}
	override @property const typeof(this) dup() {
		return Duplicate(
			GetCurrentProcess(), GetCurrentProcess(),
			ACCESSFLAG.ALL, false, DUPOPTION.SAME_ACCESS
		);
	}

	/**
	History:
		$(HIST_VER 1.120,
			$(HIST_NEW)
		)
	*/
	protected this(in Text Name, bool InitialParent, SECURITY* Security) {
		try {
			ERR.initialize;
			auto mutex=CreateMutex(Security ? Security.ptr: null, InitialParent, Name.ptr(true));
			enforce(ERR.code != ERROR_ALREADY_EXISTS, new MutexException(Text("%s [Name = %s]", ERR.toText, Name)));
			super(mutex, true);
		} catch(Throwable e) {
			throw new MutexException(Text("Mutex"), e);
		}
	}

	/**
	*/
	this(in Text Name) {
		this(Name, false, null);
	}
}

