﻿/**
ビット。

素直にstd.bitmanip.BitArray使えと。
エンディアンなんか気にもしないし考慮もしない、テストだってやってない。

History:
	$(HIST_VER 1.100,
		$(HIST_NEW)
	)
*/
module etc.negui.containers.bit;

debug import std.stdio: wl = writefln;
debug(bit) void main() {}

import std.contracts;
import std.traits;
import std.math;
import std.intrinsic;

import etc.negui.system.base;
public import etc.negui.containers.container;

///
class BitException: ContainerException {
	mixin MixInNeGuiException;
}

/**


std.intrinsicを使うのはまた今度。
etc.negui.file.file.DRIVE.drivesのために作っただけ。
*/
struct BIT(T)
if(isIntegral!(T))
{
	private enum BYTESIZE=8; /// まぁ変更はないはず
	
	private T data;
	///
	alias data this;

	/***/
	static BIT!(T) opCall(T)(T Value) {
		BIT!(T) bit;
		bit.data = Value;
		return bit;
	}
	debug(bit) unittest {
		auto b=BIT(1);
		assert(b.data == 1);
	}
	
	static {
		/**
		*/
		@property pure nothrow size_t length() {
			return T.sizeof * BYTESIZE;
		}
		/**
		*/
		pure nothrow bool isSafe(size_t Index) {
			return length > Index;
		}
		/**
		*/
		pure nothrow bool isSafe(size_t From, size_t Size) {
			return isSafe(From) && isSafe(From + Size);
		}
	}
	debug(bit) unittest {
		assert(BIT!(ubyte).length == 8);
		assert(BIT!(ushort).length == 16);
		assert(BIT!(uint).length == 32);
		assert(BIT!(ulong).length == 64);
	}
	/// Bugs: 無駄な処理。
	const Text toText() {
		// 0*.bできなかった
		string Format = "%0" ~ Text(length).str ~ "b";
		return Text(Format, data);
	}

	/**
	*/
	const bool opIndex(size_t Index) {
		enforce(isSafe(Index), new BitException(Text("T -> %s, length -> %s, Index -> %s", T.stringof, length, Index)));
		return cast(bool)(data & pow(2, Index));
	}
	debug(bit) unittest {
		BIT!(byte) bb;
		bb.data = 0b_0101_0101;
		for(auto i=0; i < bb.length; i++) {
			assert(bb[i] != i%2);
		}
		auto bi=BIT!(int)(0b_1101);
		assert(bi[0]);
		assert(!bi[1]);
		assert(bi[2]);
		assert(bi[3]);
	}
	/**
	*/
	bool opIndexAssign(bool Value, size_t Index) {
		enforce(isSafe(Index), new BitException(Text("T -> %s, length -> %s, Index -> %s", T.stringof, length, Index)));

		if(this[Index] != Value) {
			data ^= pow(2, Index);
		}
		
		return Value;
	}
	debug(bit) unittest {
		auto bi=BIT!(size_t)(0b_0101_0101);
		assert(bi[0]);
		bi[0] = false;
		assert(!bi[0]);
		bi[0] = true;
		assert(bi[0]);
		bi[0] = true;
		assert(bi[0]);
		assert(!bi[1]);
		assert(bi[1]=true);
		assert(bi[1]);
	}
	

}
debug(bit) unittest {
	BIT!(ubyte) bit;
}



