﻿/**
比較。

なんとなく。

History:
	$(HIST_VER 1.021,
		$(HIST_NEW)
	)
*/
module etc.negui.system.utility.cmp;

debug import std.stdio: wl = writefln;
debug(cmp) void main() {}

//import etc.negui.system.utility.array; // Error: struct etc.negui.system.text.Text no size yet for forward reference
//import etc.negui.system.text;
//import etc.negui.system.exception;
//import etc.negui.system.literal;
/+
///
class NeGuiCmpException: NeGuiException {
	mixin MixInNeGuiException;
}
+/


/**
*/
int Cmp(T)(T a, T b) {
	if(a == b) {
		return 0;
	}
	if(a > b) {
		return +1;
	}
	return -1;
}
debug(cmp) unittest {
	assert(Cmp(0, 0) == 0);
	assert(Cmp(1, 0) == +1);
	assert(Cmp(0, 1) == -1);
	
	assert(Cmp("abc", "abc") == 0);
	assert(Cmp("def", "abc") == +1);
	assert(Cmp("abc", "def") == -1);
}

/**
History:
	$(HIST_VER 1.120,
		$(HIST_NEW)
	)
*/
pure nothrow bool IsIn(T)(in T Target, in T[] Args) {
	foreach(ref Arg; Args) {
		if(Target == Arg) {
			return true;
		}
	}
	return false;
}
/// ditto
pure nothrow bool IsIn(T)(in T Target, in T Arg, in T[] Args ...) {
	return IsIn(Target, Arg ~ Args);
}
debug(cmp) unittest {
	assert(IsIn(0, [1, 2, 3, 0]));
	assert(IsIn(0, 0));
	assert(IsIn(0, 0, 1, 2, 3));
	assert(IsIn(1, 0, 1, 2, 3));
	assert(IsIn(2, 0, 1, 2, 3));
	assert(IsIn(3, 0, 1, 2, 3));
	assert(!IsIn(4, 0, 1, 2, 3));
}

/**
History:
	$(HIST_VER 1.120,
		$(HIST_NEW)
	)
*/
bool between(T)(in T Target, in T Small, in T Big) {
	return Small <= Target && Target <= Big;
}
debug(cmp) unittest {
	assert(between(0, 0, 100));
	assert(between(10, 0, 100));
	assert(between(100, 0, 100));
	assert(!between(-1, 0, 100));
	assert(!between(101, 0, 100));
}

