﻿/**
統合アーカイバ。

動的に使用することを前提。


Note:
	API仕様とかまったく知らないのけどとりあえずラップしてみる。
	未確認だけどAPI自体は呼び出せるはず。

ToDo:
	とりあえずmodule/package作っただけ。
*/
module etc.negui.wrapper.commonarchivers.commonarchivers;

debug import etc.negui.nestdio: wl = writefln;
debug(commonarchivers) void main() {}

public import std.c.time;

import std.contracts;
import std.math;

import etc.negui.system.base;
import etc.negui.system.literal;
public import etc.negui.file.dll;
import etc.negui.window.window;
import etc.negui.wrapper.wrapper;
public import etc.negui.wrapper.commonarchivers.header;

///
class CommonArchiversException: WrapperException {
	mixin MixInNeGuiException;
}

///
interface ICommonArchivers {
	
}

///
class CommonArchiver: DLL, ICommonArchivers, IWrapper, IInitialize {
	mixin MixInWrapper!(this.stringof);
	/// 頭。
	protected const Text _head;
	
	///
	extern(Windows) {
		BOOL function(LPCSTR _szFileName, INT _iMode) CheckArchiveA;
		BOOL function(LPCWSTR _szFileName, INT _iMode) CheckArchiveW;
		BOOL function() ClearEnumMembersProc;
		BOOL function() ClearEnumMembersProc64;
		BOOL function() ClearOwnerWindow;
		BOOL function(HWND _hwnd, LPSTR _lpszComBuffer, INT _iMode) ConfigDialogA;
		BOOL function(HWND _hwnd, LPWSTR _lpszComBuffer, INT _iMode) ConfigDialogW;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllLastAccessTime) GetAccessTime64;
		BOOL function(HARC _harc, FILETIME *_lpftLastAccessTime) GetAccessTimeEx;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllLastAccessTime) GetArcAccessTime64;
		BOOL function(HARC _harc, FILETIME *_lpftLastAccessTime) GetArcAccessTimeEx;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllSize) GetArcCompressedSizeEx;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllCreationTime) GetArcCreateTime64;
		BOOL function(HARC _harc, FILETIME *_lpftCreationTime) GetArcCreateTimeEx;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllSize) GetArcFileSizeEx;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllSize) GetArcOriginalSizeEx;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllSize) GetArcReadSizeEx;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllLastWriteTime) GetArcWriteTime64;
		BOOL function(HARC _harc, FILETIME *_lpftLastWriteTime) GetArcWriteTimeEx;
		BOOL function() GetBackGroundMode;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllSize) GetCompressedSizeEx;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllCreationTime) GetCreateTime64;
		BOOL function(HARC _harc, FILETIME *_lpftCreationTime) GetCreateTimeEx;
		BOOL function() GetCursorMode;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllSize) GetOriginalSizeEx;
		BOOL function() GetRunning;
		BOOL function(HARC _harc, ULHA_INT64 *_lpllLastWriteTime) GetWriteTime64;
		BOOL function(HARC _harc, FILETIME *_lpftLastWriteTime) GetWriteTimeEx;
		BOOL function(HWND _hwnd) KillOwnerWindowEx;
		BOOL function(HWND _hwnd) KillOwnerWindowEx64;
		BOOL function(INT _iFunction) QueryFunctionList;
		BOOL function(BOOL _BackGroundMode) SetBackGroundMode;
		BOOL function(UINT _uCodePage) SetCP;
		BOOL function(WORD _Interval) SetCursorInterval;
		BOOL function(BOOL _CursorMode) SetCursorMode;
		BOOL function(UNLHA_WND_ENUMMEMBPROC _lpEnumProc, DWORD _dwStructSize) SetEnumMembersProc64;
		BOOL function(UNLHA_WND_ENUMMEMBPROC _lpEnumProc) SetEnumMembersProcA;
		BOOL function(UNLHA_WND_ENUMMEMBPROC _lpEnumProc) SetEnumMembersProcW;
		BOOL function() SetLangueEnglish;
		BOOL function() SetLangueJapanese;
		BOOL function(LANGID _wLanguage) SetLangueSpecified;
		BOOL function(HWND _hwnd) SetOwnerWindowA;
		BOOL function(HWND _hwnd, LPARCHIVERPROC _lpArcProc, DWORD _dwStructSize) SetOwnerWindowEx64;
		BOOL function(HWND _hwnd, LPARCHIVERPROC _lpArcProc) SetOwnerWindowExA;
		BOOL function(HWND _hwnd, LPARCHIVERPROC _lpArcProc) SetOwnerWindowExW;
		BOOL function(HWND _hwnd) SetOwnerWindowW;
		BOOL function(BOOL _bUnicode) SetUnicodeMode;
		DWORD function(HARC _harc) GetAccessTime;
		DWORD function(HARC _harc) GetArcAccessTime;
		DWORD function(HARC _harc) GetArcCompressedSize;
		DWORD function(HARC _harc) GetArcCreateTime;
		DWORD function(HARC _harc) GetArcFileSize;
		DWORD function(HARC _harc) GetArcOriginalSize;
		DWORD function(HARC _harc) GetArcReadSize;
		DWORD function(HARC _harc) GetArcWriteTime;
		DWORD function(HARC _harc) GetCRC;
		DWORD function(HARC _harc) GetCompressedSize;
		DWORD function(HARC _harc) GetCreateTime;
		DWORD function(HARC _harc) GetOriginalSize;
		DWORD function(HARC _harc) GetWriteTime;
		HARC function(HWND _hwnd, LPCSTR _szFileName, DWORD _dwMode, LPCSTR _szOption) OpenArchive2A;
		HARC function(HWND _hwnd, LPCWSTR _szFileName, DWORD _dwMode, LPCWSTR _szOption) OpenArchive2W;
		HARC function(HWND _hwnd, LPCSTR _szFileName, DWORD _dwMode) OpenArchiveA;
		HARC function(HWND _hwnd, LPCWSTR _szFileName, DWORD _dwMode) OpenArchiveW;
		UINT function(HARC _harc) GetArcOSType;
		UINT function() GetCP;
		UINT function(HARC _harc) GetOSType;
		WORD function(HARC _harc) GetArcDate;
		WORD function(HARC _harc) GetArcRatio;
		WORD function(HARC _harc) GetArcTime;
		WORD function() GetCursorInterval;
		WORD function(HARC _harc) GetDate;
		WORD function(HARC _harc) GetRatio;
		WORD function() GetSubVersion;
		WORD function(HARC _harc) GetTime;
		WORD function() GetVersion;
		INT function(HARC _harc) CloseArchive;
		INT function(HWND _hwndParent, LPCSTR _szCmdLine, LPBYTE _lpBuffer, DWORD _dwSize, time_t *_lpTime, LPWORD _lpwAttr, LPDWORD _lpdwWriteSize) CompressMemA;
		INT function(HWND _hwndParent, LPCWSTR _szCmdLine, LPBYTE _lpBuffer, DWORD _dwSize, time_t *_lpTime, LPWORD _lpwAttr, LPDWORD _lpdwWriteSize) CompressMemW;
		INT function(HWND _hwndParent, LPCSTR _szCmdLine, LPBYTE _lpBuffer, DWORD _dwSize, time_t *_lpTime, LPWORD _lpwAttr, LPDWORD _lpdwWriteSize) ExtractMemA;
		INT function(HWND _hwndParent, LPCWSTR _szCmdLine, LPBYTE _lpBuffer, DWORD _dwSize, time_t *_lpTime, LPWORD _lpwAttr, LPDWORD _lpdwWriteSize) ExtractMemW;
		INT function(HARC _harc, LPCSTR _szWildName, INDIVIDUALINFOA *_lpSubInfo) FindFirstA;
		INT function(HARC _harc, LPCWSTR _szWildName, INDIVIDUALINFOW *_lpSubInfo) FindFirstW;
		INT function(HARC _harc, INDIVIDUALINFOA *_lpSubInfo) FindNextA;
		INT function(HARC _harc, INDIVIDUALINFOW *_lpSubInfo) FindNextW;
		INT function(HARC _harc, LPSTR _lpBuffer, INT _nSize) GetArcFileNameA;
		INT function(HARC _harc, LPWSTR _lpBuffer, INT _nSize) GetArcFileNameW;
		INT function(HARC _harc) GetAttribute;
		INT function(HARC _harc) GetAttributes;
		INT function(LPCSTR _szArcFile) GetFileCountA;
		INT function(LPCWSTR _szArcFile) GetFileCountW;
		INT function(HARC _harc, LPSTR _lpBuffer, INT _nSize) GetFileNameA;
		INT function(HARC _harc, LPWSTR _lpBuffer, INT _nSize) GetFileNameW;
		INT function(LPDWORD _lpdwSystemError) GetLastError;
		INT function(HARC _harc, LPSTR _lpBuffer, INT _nSize) GetMethodA;
		INT function(HARC _harc, LPWSTR _lpBuffer, INT _nSize) GetMethodW;
		INT function(HARC _harc) IsSFXFile;
		/// コマンド。
		INT function(HWND _hwnd, LPCSTR _szCmdLine, LPSTR _szOutput, DWORD _dwSize) CommandA;
		/// ditto
		INT function(HWND _hwnd, LPCWSTR _szCmdLine, LPWSTR _szOutput, DWORD _dwSize) CommandW;
		version(Unicode) {
			alias CheckArchiveW CheckArchive;
			alias ConfigDialogW ConfigDialog;
			alias SetEnumMembersProcW SetEnumMembersProc;
			alias SetOwnerWindowExW SetOwnerWindowEx;
			alias OpenArchiveW OpenArchive;
			alias FindFirstW FindFirst;
			alias FindNextA FindNext;
			alias GetArcFileNameW GetArcFileName;
			alias GetFileCountW GetFileCount;
			alias GetFileNameW GetFileName;
			alias GetMethodW GetMethod;
			alias CommandW Command;
		} else {
			alias CheckArchiveA CheckArchive;
			alias ConfigDialogA ConfigDialog;
			alias SetEnumMembersProcA SetEnumMembersProc;
			alias SetOwnerWindowExA SetOwnerWindowEx;
			alias OpenArchiveA OpenArchive;
			alias FindFirstA FindFirst;
			alias FindNextW FindNext;
			alias GetArcFileNameA GetArcFileName;
			alias GetFileCountA GetFileCount;
			alias GetFileNameA GetFileName;
			alias GetMethodA GetMethod;
			alias CommandA Command;
		}
	}
	protected static pure nothrow {
		string SMixInCommonArchiverAPI(string Head, string FuncPtr, string FuncName) {
			return `

			` ~ FuncPtr ~` = address!(typeof(` ~ FuncPtr ~`))
			(Text(` ~ Head ~ ` ~ ` ~ FuncName ~`.stringof["this".length+1 .. $]));

			`;
		}
		string SMixInCommonArchiver(string FuncPtr, string FuncName) {
			return SMixInCommonArchiverAPI(q{_head.str}, FuncPtr, FuncName);
		}
		string SMixInCA(string FuncPtr) {
			return SMixInCommonArchiverAPI(q{_head.str}, FuncPtr, FuncPtr);
		}
		string SMixInCAs(string[] FuncPtrs) {
			string s;
			for(auto i=0; i < FuncPtrs.length; i++) {
				s ~= SMixInCA(FuncPtrs[i]);
			}
			return s;
		}
	}
	
	/**
	関数を全て読み込む。

	Inheritance:
		共通部分はこいつで読み込めるようにしたい。
	*/
	override void initialize() {
		mixin(SMixInCAs([
			q{CheckArchiveA}, q{CheckArchiveW},
			q{ClearEnumMembersProc},
			q{ClearEnumMembersProc64},
			q{ClearOwnerWindow},
			q{ConfigDialogA}, q{ConfigDialogW},
			q{GetAccessTime64},
			q{GetAccessTimeEx},
			q{GetArcAccessTime64},
			q{GetArcAccessTimeEx},
			q{GetArcCompressedSizeEx},
			q{GetArcCreateTime64},
			q{GetArcCreateTimeEx},
			q{GetArcFileSizeEx},
			q{GetArcOriginalSizeEx},
			q{GetArcReadSizeEx},
			q{GetArcWriteTime64},
			q{GetArcWriteTimeEx},
			q{GetBackGroundMode},
			q{GetCompressedSizeEx},
			q{GetCreateTime64},
			q{GetCreateTimeEx},
			q{GetCursorMode},
			q{GetOriginalSizeEx},
			q{GetRunning},
			q{GetWriteTime64},
			q{GetWriteTimeEx},
			q{KillOwnerWindowEx},
			q{KillOwnerWindowEx64},
			q{QueryFunctionList},
			q{SetBackGroundMode},
			q{SetCP},
			q{SetCursorInterval},
			q{SetCursorMode},
			q{SetEnumMembersProc64},
			q{SetEnumMembersProcA}, q{SetEnumMembersProcW},
			q{SetLangueEnglish},
			q{SetLangueJapanese},
			q{SetLangueSpecified},
			q{SetOwnerWindowA}, q{SetOwnerWindowW},
			q{SetOwnerWindowEx64},
			q{SetOwnerWindowExA}, q{SetOwnerWindowExW},
			q{SetUnicodeMode},
			q{GetAccessTime},
			q{GetArcAccessTime},
			q{GetArcCompressedSize},
			q{GetArcCreateTime},
			q{GetArcFileSize},
			q{GetArcOriginalSize},
			q{GetArcReadSize},
			q{GetArcWriteTime},
			q{GetCRC},
			q{GetCompressedSize},
			q{GetCreateTime},
			q{GetOriginalSize},
			q{GetWriteTime},
			q{OpenArchive2A}, q{OpenArchive2W},
			q{OpenArchiveA}, q{OpenArchiveW},
			q{GetArcOSType},
			q{GetCP},
			q{GetOSType},
			q{GetArcDate},
			q{GetArcRatio},
			q{GetArcTime},
			q{GetCursorInterval},
			q{GetDate},
			q{GetRatio},
			q{GetSubVersion},
			q{GetTime},
			q{GetVersion},
			q{CloseArchive},
			q{CompressMemA}, q{CompressMemW},
			q{ExtractMemA}, q{ExtractMemW},
			q{FindFirstA}, q{FindFirstW},
			q{FindNextA}, q{FindNextW},
			q{GetArcFileNameA}, q{GetArcFileNameW},
			q{GetAttribute},
			q{GetAttributes},
			q{GetFileCountA}, q{GetFileCountW},
			q{GetFileNameA}, q{GetFileNameW},
			q{GetLastError},
			q{GetMethodA}, q{GetMethodW},
			q{IsSFXFile}
		]));
		
		CommandA = address!(typeof(CommandA))(Text(_head ~ Text('A')));
		CommandW = address!(typeof(CommandW))(Text(_head ~ Text('W')));
	}
	///
	this(in Text Path, in Text HeadName) {
		try {
			super(Path);
			_head = HeadName.dup;
		} catch(DllException e) {
			new CommonArchiversException(Text("wrapperName -> %s", wrapperName), e);
		}
	}

	// 鬼のラップ作業開始 -------------------------------------------------

	/**
	バージョン情報取得。

	Returns:
		DLLバージョン。
	
		ドキュメント中ではバージョンは$(DEFINE 1.23.4.5)として$(DEFINE a.bc.d.e)と読み替える。
		戻り値の要素ごとに各値が設定される。

		戻り値の配列はarray[a, bc, d, e]となる。

		DLLバージョンが0.20未満の場合、d, eの部分は0。

		$(TABLE
			$(TABLE_CAPTION UNLHA32.DLL, API.TXT参照)
			$(TABLE_HEAD
				$(TABLE_ROW
					$(TABLE_COL_HEAD バージョン)
					$(TABLE_COL_HEAD 意味)
				)
			)
			$(TABLE_BODY
				$(TABLE_ROW
					$(TABLE_COL_HEAD a)
					$(TABLE_COL_DATA メジャーバージョン。)
				)
				$(TABLE_ROW
					$(TABLE_COL_HEAD b)
					$(TABLE_COL_DATA APIの追加や仕様変更の際には必ずインクリメントされます。)
				)
				$(TABLE_ROW
					$(TABLE_COL_HEAD c)
					$(TABLE_COL_DATA 改版のたびにインクリメントされます。 返却値の仕様から， 10 回改版されれば API の変更等にかかわらず b のほうもインクリメントされる結果となることに注意してください。)
				)
				$(TABLE_ROW
					$(TABLE_COL_HEAD d)
					$(TABLE_COL_DATA 修正バージョンやβ版等， 改版に満たない修正版の際にインクリメントされます。 ドキュメント等で 1.45a となっていれば  a の部分を表します。b なら 2 となります。)
				)
				$(TABLE_ROW
					$(TABLE_COL_HEAD e)
					$(TABLE_COL_DATA 版においてのパッチレベル。レベルが 100 を超えると d が一つインクリメントされます。)
				)
			)
		)
	
	Wrappers:
		$(LIST_UNORDERED
			$(LIST_ITEM GetVersion)
			$(LIST_ITEM GetSubVersion)
		)
	*/
	const ubyte[4] getVersion() {
		auto TopValue=GetVersion();
		immutable real Version=TopValue / 100;
		ubyte[4] Versions;
		Versions[0] = cast(ubyte)(TopValue / 100);
		Versions[1] = cast(ubyte)(TopValue % 100);
		
		// 0.20以上は下位も取得。
		if(TopValue >= 20 && GetSubVersion) {
			immutable SubValue=GetSubVersion();
			Versions[2] = cast(ubyte)(SubValue / 100);
			Versions[3] = cast(ubyte)(SubValue % 100);
		}
		
		return Versions;
	}
	/**
	バージョン情報文字列取得。

	Returns:
		getVersionで取得した内容を書式化した文字列。

	Note:
		$(STRONG d)の部分が[a-z]までしか対応できてないけど問題ないはず。
	*/
	const Text getVersionText() {
		auto Versions=getVersion();
		tstring str="%s.%02s";
		if(Versions[2]) {
			tchar c = cast(tchar)(Versions[2] + 'a' - 1);
			if(Versions[3]) {
				return Text(str ~ c ~ ".%02s", Versions[0], Versions[1], Versions[2], Versions[3]);
			}
			return Text(str ~ c, Versions[0], Versions[1], Versions[2]);
		}
		return Text(str, Versions[0], Versions[1]);
	}

	/**
	現在のAPI動作確認。
	
	Returns:
		動作中であればtrue、非動作中ならfalse。

		trueの場合はAPIの実行が出来ない。

	Wrappers:
		$(LIST_UNORDERED
			$(LIST_ITEM GetRunning)
		)
	*/
	const bool isRunning() {
		return cast(bool)GetRunning();
	}

	/**
	バックグラウンドモードの確認。

	Wrappers:
		$(LIST_UNORDERED
			$(LIST_ITEM GetBackGroundMode)
		)
	*/
	const bool backGroundMode() {
		return cast(bool)GetBackGroundMode();
	}
	/**
	バックグラウンドモードを設定。

	Params:
		Mode = バックグラウンドモードの状態。
		       trueでバックグラウンドモード、falseで非バックグラウンドモード。

	Returns:
		成功時にtrue、失敗時にfalse。

		詳細はlastError参照。

	Wrappers:
		$(LIST_UNORDERED
			$(LIST_ITEM SetBackGroundMode)
		)
	*/
	bool backGroundMode(bool Mode) {
		return cast(bool)SetBackGroundMode(Mode);
	}

	/**
	独自カーソル表示状態取得。
	

	Wrappers:
		$(LIST_UNORDERED
			$(LIST_ITEM GetCursorMode)
		)
	*/
	const bool cursorMode() {
		return cast(bool)GetCursorMode();
	}
	/**
	独自カーソル表示設定。
	

	Wrappers:
		$(LIST_UNORDERED
			$(LIST_ITEM SetCursorMode)
		)
	*/
	bool cursorMode(bool Mode) {
		return cast(bool)SetCursorMode(Mode);
	}

	///
	enum WORD CURSOR_INTERVAL = 80;
	
	/**
	独自カーソルの回転速度取得。

	Returns:
		回転速度をミリ秒で返す。

	Wrappers:
		$(LIST_UNORDERED
			$(LIST_ITEM GetCursorInterval)
		)
	*/
	const WORD cursorInterval() {
		return GetCursorInterval();
	}

	/**
	独自カーソルの回転速度設定。

	Params:
		Ms = ミリ秒。

	Returns:
		成功の真偽値。

	Wrappers:
		$(LIST_UNORDERED
			$(LIST_ITEM SetCursorInterval)
		)
	*/
	bool cursorInterval(WORD Ms) {
		return cast(bool)SetCursorInterval(Ms);
	}

	/**
	コマンド。

	Bugs:
		A, Wと0.01から実装されているやつ、とりあえず全てにおいて微妙すぎる。

	*/
	Text command(in Window window, in Text cmd, size_t Buffer=BUFFER.TEXT) {
		static void Throws(INT Code, string _file=__FILE__, int _line=__LINE__) {
			enforce(Code, new CommonArchiversException(Text(Code), null, _file, _line));
		}
		INT ResultCode;
		
		if(Command) {
			auto Output=new tchar[Buffer];
			ResultCode = Command(window ? window(): null, cmd.ptr, Output.ptr, Output.length);
			Throws(ResultCode);
			return Text(Output.ptr);
		} else {
			auto Output=new char[Buffer];
			auto Cmd = address!(typeof(CommandA))(_head);
			ResultCode = Cmd(window ? window(): null, cmd.toStringz!(char), Output.ptr, Output.length);
			Throws(ResultCode);
			return Text(Output.ptr);
		}
	}
	/+
	/// ditto
	Text command(in Text cmd, size_t Buffer=BUFFER.TEXT) {
		return command(null, cmd, Buffer);
	}
	+/
}


